Package org.optaplanner.core.impl.score.stream.drools.tri

## Class DroolsScoringTriConstraintStream<Solution_,​A,​B,​C>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>
      - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsScoringTriConstraintStream<Solution_,​A,​B,​C>

- All Implemented Interfaces:
    `ConstraintStream`, `TriConstraintStream<A,​B,​C>`, `InnerTriConstraintStream<A,​B,​C>`

      public final class DroolsScoringTriConstraintStream<Solution_,​A,​B,​C>
      extends DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `parent`

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent)` |
    `DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, ToIntTriFunction<A,​B,​C> intMatchWeigher)` |
    `DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, ToLongTriFunction<A,​B,​C> longMatchWeigher)` |
    `DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​BigDecimal> bigDecimalMatchWeigher)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `List<org.drools.model.RuleItemBuilder<?>>` | `createRuleItemBuilders​(DroolsConstraint<?> constraint, org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal)` | Assemble elements of the rule that will process this stream and turn it into a constraint match.
    `DroolsTriCondition<A,​B,​C,​?>` | `getCondition()` |
    `Class[]` | `getExpectedJustificationTypes()` | As defined by `DroolsRuleStructure.getExpectedJustificationTypes()`.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `filter, getCardinality, getFromStreamList, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, getChildStreams, getConstraintFactory`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.tri.InnerTriConstraintStream

      `impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.tri.TriConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsScoringTriConstraintStream

          public DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent)

    - #### DroolsScoringTriConstraintStream

          public DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                  ToIntTriFunction<A,​B,​C> intMatchWeigher)

    - #### DroolsScoringTriConstraintStream

          public DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                  ToLongTriFunction<A,​B,​C> longMatchWeigher)

    - #### DroolsScoringTriConstraintStream

          public DroolsScoringTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                  TriFunction<A,​B,​C,​BigDecimal> bigDecimalMatchWeigher)

  - ### Method Detail

    - #### createRuleItemBuilders

          public List<org.drools.model.RuleItemBuilder<?>> createRuleItemBuilders​(DroolsConstraint<?> constraint,
                                                                                  org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal)

      Description copied from class: `DroolsAbstractConstraintStream`
      Assemble elements of the rule that will process this stream and turn it into a constraint match. Will be ignored unless on a scoring stream such as `DroolsScoringUniConstraintStream`.
      Overrides:
        `createRuleItemBuilders` in class `DroolsAbstractConstraintStream<Solution_>`
      Parameters:
        `constraint` - constraint which is being scored
        `scoreHolderGlobal` - contains the score to be affected
      Returns:
        rule representing this constraint stream

    - #### getCondition

          public DroolsTriCondition<A,​B,​C,​?> getCondition()

      Specified by:
        `getCondition` in class `DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>`

    - #### getExpectedJustificationTypes

          public Class[] getExpectedJustificationTypes()

      Description copied from class: `DroolsAbstractConstraintStream`
      As defined by `DroolsRuleStructure.getExpectedJustificationTypes()`. May only be called on scoring streams.
      Overrides:
        `getExpectedJustificationTypes` in class `DroolsAbstractConstraintStream<Solution_>`
      Returns:
        never null, never empty

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`